/*
* This Plugin allows aliens to donate res to other players and
* distribute his res when leaving
* Say giveres x or type in console giveres x while looking at player to donate
*
* amx_donateres_cvar gorgeonly 1/0	: player can only donate to gorge
* amx_donateres_cvar tax x		: how much to pay for transfer (percent)
* amx_donateres_cvar shareonexit 1/0	: player share res on disconnect on/off
* amx_donateres 1/0 or on/off		: turns Donate Res on/off
*
* by White Panther
*
* v1.0:
*	- first release
*
* v1.1.5:
*	- bug fixed where only skulks could donate to skulks, gorge to gorge, ...
*	- bug where gorgeonly could not be turned off after enabling
*	- res of players that leave can be distribute to all others (use "amx_donateres_cvar shareonexit 0" to disable )
*	- fixed bug where player could disconnect, distribute res, connect again and still has his res
*
* v1.2.2b:
*	- now working with NS 3 b5
*	- minor adjustments / fixes
*	- moved from ns2amx to engine + fakemeta + ns
*	- fixed bug for 32 players
*
* v1.2.3:
*	- minor code fixes
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <ns>

//#define RES_OFFSET 0x18E

new GRrunning = 1
new Float:bonusres[33]
new disconnected[33]

#define cvar_num	3

new svar[cvar_num][] = {
		"gorgeonly",
		"tax",
		"shareonexit"
	}

new ivar[cvar_num][] = {
		"0",
		"10",
		"1"
	}

new infovar[cvar_num][] = {
		"specify if player can only donate to gorges (on/off)",
		"how much tax is paid for the transfer (in percent)",
		"player share res on disconnect on/off"
	}

/* Init and forwards */
public plugin_init(){  
	register_plugin("Donate Res","1.2.3","White Panther")
	register_concmd("amx_donateres","amx_donateres",ADMIN_LEVEL_E,"<on/off> or <1/0> turns Donate Res on or off")
	register_concmd("amx_donateres_cvar","amx_donateres_cvar",ADMIN_LEVEL_E,"type ^"amx_donateres_cvar list^" to get all available cvars")
	register_clcmd("giveres","donate_res")
	register_clcmd("say","donate_res_say")
	new a
	for( a = 0; a < cvar_num; a++ )
		register_cvar(svar[a],ivar[a])
}

public plugin_modules(){
	require_module("engine")
	require_module("fakemeta")
	require_module("ns")
}

public client_connect(id){
	bonusres[id] = 0.0
}

public client_disconnect(id){
	bonusres[id] = 0.0
	/* share res */
	if ( get_cvar_num("shareonexit") == 1 ){
		if ( 1 <= ns_get_class(id) <= 5 ){
			new allid[32], allnum, alienid[32], aliennum = 0
			get_players(allid, allnum)
			for ( new a = 0; a < allnum; a++ ){
				if ( 3 <= get_user_team(id) <= 9 ){
					alienid[aliennum] = allid[a]
					aliennum += 1
				}
			}
			if ( aliennum > 1 ){
				new Float:restoshare = ns_get_res(id) / (aliennum-1) *1.0
				new b
				for ( b = 0; b < aliennum; b++ ){
					if ( alienid[b] != id ){
						ns_set_res(alienid[b],ns_get_res(alienid[b]) + restoshare )
					}
				}
			}
			disconnected[id] = 1
		}
	}
}

public client_changeclass(id,newclass,oldclass){
	if ( is_user_connected(id) ){
		if ( 1 <= newclass <= 5 ){
			if ( disconnected[id] ){
				new Userid[1]
				Userid[0] = id
				set_task(5.0,"resetres",id,Userid,1) // 5 secs, cause ns changes it after ~ 3-5 secs
			}
		}
	}
}

/* Donateres */
public amx_donateres(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new onoff[5]
	read_argv(1,onoff,4)
	if ( equal(onoff,"on") || equal(onoff,"1") ){
		if ( GRrunning == 1 ){
			console_print(id,"Donate Res already enabled")
		}else{
			GRrunning = 1
			console_print(id,"Donate Res enabled")
			client_print(0,print_chat,"[AMX] Admin has turned on Donate Res")
		}
		return PLUGIN_HANDLED
	}
	if ( equal(onoff,"off") || equal(onoff,"0") ){
		if ( GRrunning == 0 ){
			console_print(id,"Donate Res already disabled")
		}else{
			GRrunning = 0
			console_print(id,"Donate Res disabled")
			client_print(0,print_chat,"[AMX] Admin has turned off Donate Res")
		}
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public amx_donateres_cvar(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg1[41],arg2[5]
	read_argv(1,arg1,40)
	read_argv(2,arg2,4)
	if ( cvar_exists(arg1) ){
		new var_num = str_to_num(arg2)
		if ( equali(arg2,"") ){
			new a, num
			for ( a = 0; a < cvar_num; a++ ){
				if ( equal(arg1,svar[a]) ){
					num = a
					break
				}
			}
			console_print(id,"%s currently set to %i    |    %s",arg1,get_cvar_num(arg1),infovar[num])
		}else{
			set_cvar_num(arg1,var_num)
			console_print(id,"%s set to %i",arg1,var_num)
		}
	}else if ( equal(arg1,"list") ){
		console_print(id,"%4s %s %22s %5s       %s"," ","Cvars:"," ","Value:","Info:")
		new a
		for ( a = 0; a < cvar_num; a++ ){
			console_print(id,"%3d: %18.18s %10d    |    %s",a+1,svar[a],get_cvar_num(svar[a]),infovar[a])
		}
	}else{
		console_print(id,"Not a valid cvar, type ^"amx_donateres_cvar list^" to get all available cvars")
	}
	return PLUGIN_HANDLED
}


public donate_res(id){
	if ( 1 <= ns_get_class(id) <= 5 ){
		new res[4]
		read_argv(1,res,3)
		check_and_donate(id,str_to_num(res))
	}
	return PLUGIN_HANDLED
}

public donate_res_say(id){
	if ( 1 <= ns_get_class(id) <= 5 ){
		new Speech[31]
		read_args(Speech,30)
		remove_quotes(Speech)
		if ( containi(Speech, "giveres") == 0 ){
			new i, res = 0
			for ( i = 0; Speech[i]; i++ ){ 
				if ( isdigit(Speech[i]) ){
					res = str_to_num(Speech[i])
					break
				} 
			}
			check_and_donate(id,res)
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_CONTINUE
}

/* additional Functions */
check_and_donate(id,res){
	new aimedid, dummy
	get_user_aiming(id,aimedid,dummy,120)
	//if ( ( 1 <= ns_get_class(id) <= 5 ) && ( 1 <= ns_get_class(aimedid) <= 5 ) ){
	if ( pev(id,pev_team) == pev(aimedid,pev_team) ){
		if ( GRrunning == 1 ){
			if ( res > 0 ){
				if ( is_user_connected(aimedid) ){
					if ( ns_get_class(aimedid) == CLASS_GORGE || get_cvar_num("gorgeonly") != 1 ){
						new Float:userres = ns_get_res(id) - res
						if ( userres > 0 ){
							ns_set_res(id,userres)
							new Float:taxres = res * get_cvar_num("tax") / 100.0
							new Float:tempres = floatround(taxres) - taxres
							bonusres[aimedid] += tempres
							new restogive = res - floatround(taxres)
							if ( bonusres[aimedid] >= 1.0 || bonusres[aimedid] <= -1.0 ){
								restogive += floatround(bonusres[aimedid])
								bonusres[aimedid] -= floatround(bonusres[aimedid])
							}
							ns_set_res(aimedid,ns_get_res(aimedid) + restogive )
						}else
							client_print(id,print_chat,"[Donate Res] You dont have that much resources")
					}else
						client_print(id,print_chat,"[Donate Res] Player is not a Gorge")
				}else
					client_print(id,print_chat,"[Donate Res] Player is to far away")
			}else
				client_print(id,print_chat,"[Donate Res] You have to donate at least 1 res")
		}else
			client_print(id,print_chat,"[Donate Res] Donating is currently off")
	}else
		client_print(id,print_chat,"[Donate Res] You have to look at a player in your team")
}

/* Timer Functions */
public resetres(id[]){
	ns_set_res(id[0],0.1)
	disconnected[id[0]] = 0
}